import com.aliyun.imagesearch.Client;
import com.aliyun.imagesearch.models.*;
import com.aliyun.tea.TeaException;
import com.aliyun.teautil.models.RuntimeOptions;

import java.io.FileInputStream;

import java.io.InputStream;
import java.util.List;

public class SimpleDemo {

    private static final String INSTANCE = "XXXXXXXX";

    public static void main(String[] args) throws Exception {
        Config authConfig = new Config();
        authConfig.accessKeyId = "XXXXXX";
        authConfig.accessKeySecret = "XXXXXXXXXX";
        authConfig.type = "access_key";
        authConfig.endpoint = "imagesearch.cn-shanghai.aliyuncs.com";
        authConfig.regionId = "cn-shanghai";
        Client client = new Client(authConfig);

        String path = "/home/admin/123.jpg";
        SimpleDemo demo = new SimpleDemo();
        demo.add(path,client);
        //demo.searchByPic(path,client);
        //demo.searchByName(client);
        //demo.delete(client);
    }

    public void add(String path,Client client) throws Exception {
        String picName = path;
        AddImageAdvanceRequest request = new AddImageAdvanceRequest();
        // 必填，图像搜索实例名称。
        request.instanceName = INSTANCE;
        // 必填，商品id，最多支持 512个字符。
        // 一个商品可有多张图片。
        request.productId = "test";
        // 必填，图片名称，最多支持 512个字符。
        // 1. ProductId + PicName唯一确定一张图片。
        // 2. 如果多次添加图片具有相同的ProductId + PicName，以最后一次添加为准，前面添加的的图片将被覆盖。
        request.picName = "1000";
        // 选填，图片类目。
        // 1. 对于商品搜索：若设置类目，则以设置的为准；若不设置类目，将由系统进行类目预测，预测的类目结果可在Response中获取 。
        // 2. 对于布料、商标、通用搜索：不论是否设置类目，系统会将类目设置为88888888。
        request.categoryId = 3;
        // 选填，用户自定义的内容，最多支持 4096个字符。
        // 查询时会返回该字段。例如可添加图片的描述等文本。
        request.customContent = "this is a simple test";
        // 选填，整数类型属性，可用于查询时过滤，查询时会返回该字段。
        //  例如不同的站点的图片/不同用户的图片，可以设置不同的intAttr，查询时通过过滤来达到隔离的目的
        request.intAttr = 56;
        // 选填，字符串类型属性，最多支持 128个字符。可用于查询时过滤，查询时会返回该字段。
        request.strAttr = "test";
        // 选填，是否需要进行主体识别，默认为true。
        // 1. 为true时，由系统进行主体识别，以识别的主体进行搜索，主体识别结果可在Response中获取。
        // 2. 为false时，则不进行主体识别，以整张图进行搜索。
        // 3.对于布料图片搜索，此参数会被忽略，系统会以整张图进行搜索。
        request.crop = false;
        // 选填，图片的主体区域，格式为 x1,x2,y1,y2, 其中 x1,y1 是左上角的点，x2，y2是右下角的点。
        // 若用户设置了Region，则不论Crop参数为何值，都将以用户输入Region进行搜索。
        // 对于布料图片搜索，此参数会被忽略，系统会以整张图进行搜索。
        request.region = "167,467,220,407";
        InputStream inputStream = new FileInputStream(picName);
        // 必填，图片内容
        // 最多支持 2MB大小图片以及5s的传输等待时间。当前仅支持jpg和png格式图片；
        // 对于商品、商标、通用图片搜索，图片长和宽的像素必须都大于等于200，并且小于等于1024；
        // 对于布料搜索，图片长和宽的像素必须都大于等于448，并且小于等于1024；
        // 图像中不能带有旋转信息。
        request.picContentObject = inputStream;
        // 创建RuntimeObject实例并设置运行参数
        RuntimeOptions runtimeOptions = new RuntimeOptions();
        try {
            AddImageResponse response = client.addImageAdvance(request,runtimeOptions);
            System.out.println("success: " + response.success + ". message: " + response.message
                    + ". categoryId: " + response.picInfo.categoryId + ". region:" + response.picInfo.region
                    + ". requestId: " + response.requestId);

        } catch (TeaException e) {
            System.out.println(e.getCode());
            System.out.println(e.getData());
            System.out.println(e.getMessage());
            e.printStackTrace();
        }

    }

    public void searchByPic(String path,Client client) throws Exception {
        SearchImageByPicAdvanceRequest request = new SearchImageByPicAdvanceRequest();
        // 必填，图像搜索实例名称。
        request.instanceName = INSTANCE;
        // 选填，商品类目。
        // 1. 对于商品搜索：若设置类目，则以设置的为准；若不设置类目，将由系统进行类目预测，预测的类目结果可在Response中获取 。
        // 2. 对于布料、商标、通用搜索：不论是否设置类目，系统会将类目设置为88888888。
        request.categoryId = 3;
        // 选填，返回结果的数目。取值范围：1-100。默认值：10。
        request.num = 10;
        // 选填，返回结果的起始位置。取值范围：0-499。默认值：0。
        request.start = 0;
        // 选填，是否需要进行主体识别，默认为true。
        // 1.为true时，由系统进行主体识别，以识别的主体进行搜索，主体识别结果可在Response中获取。
        // 2. 为false时，则不进行主体识别，以整张图进行搜索。
        // 3.对于布料图片搜索，此参数会被忽略，系统会以整张图进行搜索。
        request.crop = false;
        // 选填，图片的主体区域，格式为 x1,x2,y1,y2, 其中 x1,y1 是左上角的点，x2，y2是右下角的点。
        // 若用户设置了Region，则不论Crop参数为何值，都将以用户输入Region进行搜索。
        // 3.对于布料图片搜索，此参数会被忽略，系统会以整张图进行搜索。
        request.region="167,467,220,407";
        // 选填，过滤条件
        // int_attr支持的操作符有>、>=、<、<=、=，str_attr支持的操作符有=和!=，多个条件之支持AND和OR进行连接。
        // 示例:
        //  1. 根据IntAttr过滤结果，int_attr>=100
        //  2. 根据StrAttr过滤结果，str_attr!="value1"
        //  3. 根据IntAttr和StrAttr联合过滤结果，int_attr=1000 AND str_attr="value1"
        request.filter="int_attr=56 AND str_attr=\"test\"";
        InputStream inputStream = new FileInputStream(path);
        // 图片内容，最多支持 2MB大小图片以及5s的传输等待时间。当前仅支持jpg和png格式图片；
        // 对于商品、商标、通用图片搜索，图片长和宽的像素必须都大于等于200，并且小于等于1024；
        // 对于布料搜索，图片长和宽的像素必须都大于等于448，并且小于等于1024；
        // 图像中不能带有旋转信息
        request.picContentObject = inputStream;

        RuntimeOptions runtimeOptions =  new RuntimeOptions();

        try {
            SearchImageByPicResponse response = client.searchImageByPicAdvance(request, runtimeOptions);
            System.out.println(response.requestId);
            System.out.println(response.picInfo.categoryId);
            System.out.println(response.picInfo.region);
            List<SearchImageByPicResponse.SearchImageByPicResponseAuctions> auctions = response.auctions;
            for(SearchImageByPicResponse.SearchImageByPicResponseAuctions auction:auctions) {
                System.out.println(auction.categoryId + " " + auction.picName + " " + auction.productId + " " + auction.customContent + " " + auction.sortExprValues + " " + auction.strAttr + " " + auction.intAttr);

            }
        } catch (TeaException e) {
            System.out.println(e.getCode());
            System.out.println(e.getData());
            System.out.println(e.getMessage());
            e.printStackTrace();
        }

    }

    public void  searchByName(Client client) throws Exception {
        SearchImageByNameRequest request = new SearchImageByNameRequest();
        // 必填，图像搜索实例名称。
        request.instanceName = INSTANCE;
        // 必填，商品id，最多支持 512个字符。
        // 一个商品可有多张图片。
        request.productId = "test";
        // 必填，图片名称，最多支持 512个字符。
        // 1. ProductId + PicName唯一确定一张图片。
        request.picName = "1000";
        // 选填，商品类目。
        // 1. 对于商品搜索：若设置类目，则以设置的为准；若不设置类目，将由系统进行类目预测，预测的类目结果可在Response中获取 。
        // 2. 对于布料、商标、通用搜索：不论是否设置类目，系统会将类目设置为88888888。
        request.categoryId = 3;
        // 选填，返回结果的数目。取值范围：1-100。默认值：10。
        request.num =10;
        // 选填，返回结果的起始位置。取值范围：0-499。默认值：0。
        request.start =0;
        // 选填，过滤条件
        // int_attr支持的操作符有>、>=、<、<=、=，str_attr支持的操作符有=和!=，多个条件之支持AND和OR进行连接。
        // 示例:
        //  1. 根据IntAttr过滤结果，int_attr>=100
        //  2. 根据StrAttr过滤结果，str_attr!="value1"
        //  3. 根据IntAttr和StrAttr联合过滤结果，int_attr=1000 AND str_attr="value1"
        request.filter = "int_attr=56 AND str_attr =\"test\"";

        RuntimeOptions runtimeOptions =  new RuntimeOptions();

        try {
            SearchImageByNameResponse response = client.searchImageByName(request, runtimeOptions);
            System.out.println(response.requestId);
            System.out.println(response.picInfo.categoryId);
            System.out.println(response.picInfo.region);
            List<SearchImageByNameResponse.SearchImageByNameResponseAuctions> auctions = response.auctions;
            for(SearchImageByNameResponse.SearchImageByNameResponseAuctions auction:auctions) {
                System.out.println(auction.categoryId + " " + auction.picName + " " + auction.productId + " " + auction.customContent + " " + auction.sortExprValues + " " + auction.strAttr + " " + auction.intAttr);
            }
        } catch (TeaException e) {
            System.out.println(e.getCode());
            System.out.println(e.getData());
            System.out.println(e.getMessage());
            e.printStackTrace();
        }
    }

    public void delete(Client client) throws Exception {
        DeleteImageRequest request = new DeleteImageRequest();
        request.instanceName = INSTANCE;

        request.productId = "test";

        request.picName = "1000";

        RuntimeOptions runtimeOptions = new RuntimeOptions();

        try {
            DeleteImageResponse response = client.deleteImage(request, runtimeOptions);
            System.out.println("requestId: " + response.requestId + ". success: " + response.success + ". message: " + response.message);
        } catch (TeaException e) {
            System.out.println(e.getCode());
            System.out.println(e.getData());
            System.out.println(e.getMessage());
            e.printStackTrace();
        }
    }
}

